
/*
 *  UnWindows 1.1.2
 *  transform.h
 *
 *  Gary Ormsby
 *  Rensselaer Polytechnic Institute
 *  Fall 1991
 *
 *  Minor revisions by Rich Burridge
 *  Sun Microsystems Inc.
 *  October 2001.
 *
 *  This is the header file for transformed coordinate system
 *  defined in transform.c.  No rotations are supported, as
 *  ellipses cannot be rotated in X.
 */

typedef struct _transform {
    double mx, bx;
    double my, by;
} Transform;

typedef struct _TPoint {
    double x, y;
} TPoint;

typedef struct _TRectangle {
    double x, y, width, height;
} TRectangle;

#define Xx(x, y, t)         ((int) ((t)->mx * (x) + (t)->bx + 0.5))
#define Xy(x, y, t)         ((int) ((t)->my * (y) + (t)->by + 0.5))
#define Xwidth(w, h, t)     ((int) ((t)->mx * (w) + 0.5))
#define Xheight(w, h, t)    ((int) ((t)->my * (h) + 0.5))
#define Tx(x, y, t)         ((((double) (x)) - (t)->bx) / (t)->mx)
#define Ty(x, y, t)         ((((double) (y)) - (t)->by) / (t)->my)
#define Twidth(w, h, t)     (((double) (w)) / (t)->mx)
#define Theight(w, h, t)    (((double) (h)) / (t)->my)

extern void
TFillArc(Display *, Drawable, GC, Transform *, double, double,
         double, double, int, int);

extern void
SetTransform(Transform *, int, int, int, int, double, double, double, double);
